var express = require('express');
var app = express();
var bodyParser = require('body-parser');
// 创建 application/x-www-form-urlencoded 编码解析
var urlencodedParser = bodyParser.urlencoded({extended: false})
var fs = require('fs')
var crypto = require('crypto');

app.get('/', function (req, res) {
    res.sendFile(__dirname + "/" + "index.html");
})

app.post('/process_get', urlencodedParser, function (req, res) {
    // JSON格式
    var response = {
        "member_id": "100026320",
        "terminal_id": "200001457",
        "pay_id": req.body.PayID,
        "order_money": parseFloat(req.body.OrderMoney) * 100,
        "trade_date": "20190226080158",
        "trans_id": "TID"+(new Date()).valueOf(),
        "product_name": "223",
        "amount": "1",
        "user_name": "",
        "notice_type": "1",
        "page_url": "http://localhost:8081",
        "return_url": "http://10.1.60.129:8081/return",
        "additional_info": ""
    };
	var keyStr = fs.readFileSync('./bfkey_100026320@@200001457.pem', 'utf8');//读取key
	var EnCodeStr = JSON.stringify(response); //先转成JSON字符串
	console.log("明文参数字符串："+EnCodeStr);
	
    /* 加密数据 */
    var encryptionData = rsaPrivateEncrypt(keyStr, '100026320_704243', EnCodeStr);
    /* 生成form表单 */
    var formHtml = createForm(encryptionData);
    res.send(formHtml);
})

app.post('/return', urlencodedParser, function (req, res) {
	console.log("==================异步通知===================");
	console.log("异步通知参数："+JSON.stringify(req.body));
	var  decodeStr = rsaPublicDecrypt("./bfkey_100026320@@200001457.cer",req.body.data_content);
	console.log("DATA_CONTENT解密:"+decodeStr);
    res.send("OK");
})

/* 加密数据
 * rsaPrivateEncrypt(私钥，私钥密码，明文数据)
 * 返回加密结果。
 */
function rsaPrivateEncrypt(keyStr, psd, enstr) {  
  var base64 = Buffer.from(enstr, 'utf8').toString('base64'); //再以utf8的形式进行base64编码
  var base64Buffer = Buffer.from(base64, 'utf8');//再以utf8的形式读取base64  
  var result = [];
  var len = 117;
  for (var i = 0; i < base64Buffer.length; i += len) {
      result.push(crypto.privateEncrypt({
          key: keyStr,
          passphrase: psd,
          padding: crypto.constants.RSA_PKCS1_PADDING
      }, base64Buffer.slice(i, Math.min(base64Buffer.length, i + len))).toString('hex'));
  }
  var resData = result.join('');
  return resData;
}

/* 解密 */
function rsaPublicDecrypt(keypath, data) {
  var key = fs.readFileSync(keypath, 'utf8');//读取key
  var bufferData = Buffer.from(data, 'hex');
  var tempbufferArr = [];
  var len = 128;
  for (var i = 0; i < bufferData.length; i += len) {
    // buffer分段解密，生成新的buffer
    var bufferSection = crypto.publicDecrypt({
        key: key,
        padding: crypto.constants.RSA_PKCS1_PADDING
    }, bufferData.slice(i, i + len));
    tempbufferArr.push(bufferSection);
  }
  //合成分段buffer
  var base64Buffer = Buffer.concat(tempbufferArr);
  //buffer转换成utf8，再以base64形式读取
  var oriBuffer = Buffer.from(base64Buffer.toString('utf8'), 'base64');
  //转换baser64格式的buffer为utf8格式，然后再解析成JSON对象。
  return oriBuffer.toString('utf8');
}


/* 创建form表单 */
function createForm(encryptionData) {
  var formHtml = '';
  formHtml += '<body onload="payForm.submit()">';
  formHtml += '<form name="payForm" action="https://vgw.baofoo.com/certpayindex" method="post">';
  formHtml += '<input type="hidden" name="member_id" value="100026320" />';
  formHtml += '<input type="hidden" name="terminal_id" value="200001457" />';
  formHtml += '<input type="hidden" name="version" value="4.2" />';
  formHtml += '<input type="hidden" name="data_content" value="' + encryptionData + '" />';
  formHtml += '<input type="submit" id="submitAuto" value="submit" style="visibility: hidden;" /></form>';
  formHtml += '</body>';
  
  console.log("请求表单："+formHtml);

  return formHtml;
}

var server = app.listen(8081, function () {
    var host = server.address().address
    var port = server.address().port
    console.log("访问地址为 http://%s:%s", host, port)
})
